## libdogleg 0.08

=== Makefile ===
API_VERSION = 2

OS = $(shell uname -s)

# I parse the version from the changelog. This version is generally something
# like 0.04-1 Here 0.04 is the main version and 1 is the debian package
# version. I only use the main version and strip leading 0s, so the above
# becomes 0.4
VERSION := $(shell sed -n 's/.*(\([0-9\.]*[0-9]\).*).*/\1/; s/\.0*/./g; p; q;' Changes)

ifeq ($(strip $(VERSION)),)
$(error "Couldn't parse version from debian/changelog")
endif

ifeq ($(OS),Darwin)
	CC = gcc # otherwise, CC defaults to clang
	SO_VERSION=$(API_VERSION).$(VERSION)
	TARGET_SO_BARE   = libdogleg.dylib
	TARGET_SO_FULL   = libdogleg.$(SO_VERSION).dylib
	TARGET_SO_SONAME = libdogleg.$(API_VERSION).dylib

# osx doesn't have DT_NEEDED or something, so I specify these explicitly
	LDLIBS += -lsuitesparseconfig -lamd -lcolamd -llapack -lblas
else
	SO_VERSION=$(API_VERSION).$(VERSION)
	TARGET_SO_BARE   = libdogleg.so
	TARGET_SO_FULL   = $(TARGET_SO_BARE).$(SO_VERSION)
	TARGET_SO_SONAME = $(TARGET_SO_BARE).$(API_VERSION)
	LDFLAGS += -Wl,-soname -Wl,libdogleg.so.$(API_VERSION)
endif

# Add my optimization flags if none already exist. These could exist if debian
# packages are built.
OPTFLAGS := $(if $(filter -O%, $(CFLAGS)),,-O3 -ffast-math -mtune=core2)

FLAGS += -ggdb  -Wall -Wextra -MMD $(OPTFLAGS) -I/usr/include/suitesparse
CFLAGS += $(FLAGS) --std=gnu99

LDLIBS += -lcholmod
LDLIBS += -lm

LIB_TARGETS = libdogleg.a $(TARGET_SO_BARE) $(TARGET_SO_FULL) $(TARGET_SO_SONAME)

MAN_SECTION = 3
MAN_TARGET = libdogleg.$(MAN_SECTION)

ALL_TARGETS = $(LIB_TARGETS) $(MAN_TARGET)

all: $(ALL_TARGETS)

libdogleg.a: dogleg.o
	ar rcvu $@ $^

$(TARGET_SO_FULL): dogleg-pic.o
	$(CC) $(LDFLAGS) -shared $^ $(LDLIBS) -o $@

$(TARGET_SO_SONAME) $(TARGET_SO_BARE): $(TARGET_SO_FULL)
	ln -fs $^ $@

%-pic.o: %.c
	$(CC) $(CPPFLAGS) -fPIC $(CFLAGS) -c -o $@ $<

$(MAN_TARGET): README.pod
	pod2man --center="libdogleg: Powell's dogleg method" --name=LIBDOGLEG --release="libdogleg $(VERSION)" --section=$(MAN_SECTION) $^ $@


sample: sample.o libdogleg.a
	$(CC) $^ $(LDLIBS) -o $@

sample.o: CFLAGS += -I.

clean:
	rm -f libdogleg.so* *.o *.a *.d $(ALL_TARGETS)

.PHONY: all clean

-include *.d

=== debian/changelog ===
libdogleg (0.08-1) unstable; urgency=low

  * Initial Debian release (Closes: #692088)

 -- Dima Kogan <dima@secretsauce.net>  Mon, 12 Nov 2012 00:25:29 -0800

=== debian/control ===
Source: libdogleg
Section: science
Priority: extra
Build-Depends: debhelper (>= 9), dh-exec, libsuitesparse-dev | libsuitesparse-metis-dev
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dima@secretsauce.net>
Standards-Version: 3.9.4
Homepage: https://github.com/dkogan/libdogleg
Vcs-Git: git://git.debian.org/git/debian-science/packages/libdogleg.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/libdogleg.git

Package: libdogleg2
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Powell's dog-leg nonlinear least squares solver for sparse matrices
 Solves unconstrained nonlinear least squares problems using Powell's dog-leg
 method. The user specifies a callback C function that returns the value and
 gradients of the model function at a particular operating point. This library
 takes a series of dog-leg steps to find a local minimum of the residual
 surface.
 .
 This library works with sparse matrices, which makes it suitable for
 efficiently solving very large problems.


Package: libdogleg-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libdogleg2 (= ${binary:Version}), libsuitesparse-dev | libsuitesparse-metis-dev
Description: Powell's dog-leg nonlinear least squares solver for sparse matrices
 Solves unconstrained nonlinear least squares problems using Powell's dog-leg
 method. The user specifies a callback C function that returns the value and
 gradients of the model function at a particular operating point. This library
 takes a series of dog-leg steps to find a local minimum of the residual
 surface.
 .
 This library works with sparse matrices, which makes it suitable for
 efficiently solving very large problems.
 .
 Development files

Package: libdogleg2-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, libdogleg2 (= ${binary:Version})
Description: Powell's dog-leg nonlinear least squares solver for sparse matrices
 Solves unconstrained nonlinear least squares problems using Powell's dog-leg
 method. The user specifies a callback C function that returns the value and
 gradients of the model function at a particular operating point. This library
 takes a series of dog-leg steps to find a local minimum of the residual
 surface.
 .
 This library works with sparse matrices, which makes it suitable for
 efficiently solving very large problems.
 .
 Debug symbols

=== debian/watch ===
version = 3
https://github.com/dkogan/libdogleg/tags .*/tarball/v(\d[\d\.]+)

## libdogleg 0.09

=== Makefile ===
--- 
+++ 
@@ -3,9 +3,7 @@
 OS = $(shell uname -s)
 
 # I parse the version from the changelog. This version is generally something
-# like 0.04-1 Here 0.04 is the main version and 1 is the debian package
-# version. I only use the main version and strip leading 0s, so the above
-# becomes 0.4
+# like 0.04 .I strip leading 0s, so the above becomes 0.4
 VERSION := $(shell sed -n 's/.*(\([0-9\.]*[0-9]\).*).*/\1/; s/\.0*/./g; p; q;' Changes)
 
 ifeq ($(strip $(VERSION)),)

=== debian/changelog ===
libdogleg (0.09-2build2) xenial; urgency=medium

  * No-change rebuild for libcholmod transition.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 09 Feb 2016 10:56:03 +0000

libdogleg (0.09-2build1) xenial; urgency=medium

  * No-change rebuild against suitesparse 1:4.4.5-2

 -- Graham Inggs <graham@nerve.org.za>  Tue, 01 Dec 2015 13:48:26 +0200

libdogleg (0.09-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable for suitesparse 4.4 transition.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 21 Nov 2015 16:06:06 +0100

libdogleg (0.09-1) experimental; urgency=medium

  * Build now works with both suitesparse 2.2 and 2.4 (Closes: #793764)

 -- Dima Kogan <dima@secretsauce.net>  Mon, 24 Aug 2015 21:38:21 -0700

libdogleg (0.08-3) unstable; urgency=low

  * Moved all docs, examples to libdogleg-doc (Closes: #735205)

 -- Dima Kogan <dima@secretsauce.net>  Mon, 13 Jan 2014 14:38:58 -0800

libdogleg (0.08-2) unstable; urgency=low

  * libdogleg is now Priority: optional
  * libdogleg is now Multi-arch:same

 -- Dima Kogan <dima@secretsauce.net>  Sun, 12 Jan 2014 23:18:46 -0800

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: libdogleg
 Section: science
-Priority: extra
+Priority: optional
 Build-Depends: debhelper (>= 9), dh-exec, libsuitesparse-dev | libsuitesparse-metis-dev
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dima@secretsauce.net>
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Homepage: https://github.com/dkogan/libdogleg
-Vcs-Git: git://git.debian.org/git/debian-science/packages/libdogleg.git
-Vcs-Browser: http://git.debian.org/?p=debian-science/packages/libdogleg.git
+Vcs-Git: git://anonscm.debian.org/debian-science/packages/libdogleg.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/libdogleg.git
 
 Package: libdogleg2
 Section: libs
 Architecture: any
+Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Powell's dog-leg nonlinear least squares solver for sparse matrices
@@ -24,11 +25,32 @@
  This library works with sparse matrices, which makes it suitable for
  efficiently solving very large problems.
 
+Package: libdogleg-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Replaces: libdogleg-dev (<< 0.08-3) 
+Breaks: libdogleg-dev (<< 0.08-3) 
+Description: Powell's dog-leg nonlinear least squares solver for sparse matrices
+ Solves unconstrained nonlinear least squares problems using Powell's dog-leg
+ method. The user specifies a callback C function that returns the value and
+ gradients of the model function at a particular operating point. This library
+ takes a series of dog-leg steps to find a local minimum of the residual
+ surface.
+ .
+ This library works with sparse matrices, which makes it suitable for
+ efficiently solving very large problems.
+ .
+ This package contains the documentation
 
 Package: libdogleg-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libdogleg2 (= ${binary:Version}), libsuitesparse-dev | libsuitesparse-metis-dev
+Multi-Arch: same
+Depends: ${misc:Depends}, libdogleg2 (= ${binary:Version}),
+         libdogleg-doc,
+         libsuitesparse-dev | libsuitesparse-metis-dev
 Description: Powell's dog-leg nonlinear least squares solver for sparse matrices
  Solves unconstrained nonlinear least squares problems using Powell's dog-leg
  method. The user specifies a callback C function that returns the value and
@@ -43,7 +65,9 @@
 
 Package: libdogleg2-dbg
 Section: debug
+Priority: extra
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, libdogleg2 (= ${binary:Version})
 Description: Powell's dog-leg nonlinear least squares solver for sparse matrices
  Solves unconstrained nonlinear least squares problems using Powell's dog-leg

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	pod2html --title=libdogleg README.pod > libdogleg.html

override_dh_strip:
	dh_strip --dbg-package=libdogleg2-dbg

override_dh_auto_clean:
	dh_auto_clean
	rm -f libdogleg.html pod2htm*.tmp

=== debian/watch ===
version = 3
https://github.com/dkogan/libdogleg/tags .*/libdogleg/archive/v(\d[\d\.]+).tar.gz

## libdogleg 0.14

=== Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 FLAGS += -ggdb  -Wall -Wextra -MMD $(OPTFLAGS) -I/usr/include/suitesparse
 CFLAGS += $(FLAGS) --std=gnu99
 
-LDLIBS += -lcholmod
+LDLIBS += -lcholmod -lsuitesparseconfig -llapack
 LDLIBS += -lm
 
 LIB_TARGETS = libdogleg.a $(TARGET_SO_BARE) $(TARGET_SO_FULL) $(TARGET_SO_SONAME)

=== debian/changelog ===
libdogleg (0.14-1) unstable; urgency=medium

  * Minor upstream update
    - gradient-testing reports are now printed in an easy-to-parse asciilog
    - CHOLMOD error callback now uses the standardized wrapped print

 -- Dima Kogan <dkogan@debian.org>  Mon, 12 Feb 2018 23:16:29 -0800

libdogleg (0.13-2) unstable; urgency=medium

  * migrated to new auto-generated debug symbol packages

 -- Dima Kogan <dkogan@debian.org>  Sun, 17 Sep 2017 02:33:32 -0700

libdogleg (0.13-1) unstable; urgency=medium

  * Upstream update
    - Added support for solving DENSE optimization problems in addition to
      sparse ones
    - Improved diagnostic printing: no console output if no errors and if
      no debug logging is requested
    - Exposed a function to compute the Cholesky factorization of JtJ
    - Clarified gradient reporting
    - Updated cholmod #includes to work without any -I flags
  * Added symbols file
  * Added the bindnow hardening flag

 -- Dima Kogan <dkogan@debian.org>  Sun, 17 Sep 2017 02:12:57 -0700

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: libdogleg
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9), dh-exec, libsuitesparse-dev | libsuitesparse-metis-dev
+Build-Depends: debhelper (>= 9.20160114), dh-exec, libsuitesparse-dev | libsuitesparse-metis-dev
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Dima Kogan <dima@secretsauce.net>
+Uploaders: Dima Kogan <dkogan@debian.org>
 Standards-Version: 3.9.6
 Homepage: https://github.com/dkogan/libdogleg
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/libdogleg.git
@@ -62,21 +62,3 @@
  efficiently solving very large problems.
  .
  Development files
-
-Package: libdogleg2-dbg
-Section: debug
-Priority: extra
-Architecture: any
-Multi-Arch: same
-Depends: ${misc:Depends}, libdogleg2 (= ${binary:Version})
-Description: Powell's dog-leg nonlinear least squares solver for sparse matrices
- Solves unconstrained nonlinear least squares problems using Powell's dog-leg
- method. The user specifies a callback C function that returns the value and
- gradients of the model function at a particular operating point. This library
- takes a series of dog-leg steps to find a local minimum of the residual
- surface.
- .
- This library works with sparse matrices, which makes it suitable for
- efficiently solving very large problems.
- .
- Debug symbols

## libdogleg 0.15.4

=== Makefile ===
--- 
+++ 
@@ -29,7 +29,7 @@
 
 # Add my optimization flags if none already exist. These could exist if debian
 # packages are built.
-OPTFLAGS := $(if $(filter -O%, $(CFLAGS)),,-O3 -ffast-math -mtune=core2)
+OPTFLAGS := $(if $(filter -O%, $(CFLAGS)),,-O3 -ffast-math -mtune=core2) -fno-omit-frame-pointer
 
 FLAGS += -ggdb  -Wall -Wextra -MMD $(OPTFLAGS) -I/usr/include/suitesparse
 CFLAGS += $(FLAGS) --std=gnu99
@@ -42,7 +42,7 @@
 MAN_SECTION = 3
 MAN_TARGET = libdogleg.$(MAN_SECTION)
 
-ALL_TARGETS = $(LIB_TARGETS) $(MAN_TARGET)
+ALL_TARGETS = $(LIB_TARGETS) $(MAN_TARGET) sample
 
 all: $(ALL_TARGETS)

=== debian/changelog ===
libdogleg (0.15.4-2) unstable; urgency=medium

  * Fixed watch file

 -- Dima Kogan <dkogan@debian.org>  Thu, 11 Nov 2021 22:24:27 -0800

libdogleg (0.15.4-1) unstable; urgency=medium

  * New upstream release
    - added experimental outlier-rejection logic. Not stable and not fully
      documented
    - verbose output has a mode to output vnlog
    - Added dogleg_optimize2() and dogleg_optimize_dense2() entry points
      that use local parameters

 -- Dima Kogan <dkogan@debian.org>  Fri, 11 Dec 2020 15:41:39 -0800

libdogleg (0.15-1) unstable; urgency=medium

  * updated Vcs tags to salsa
  * New upstream version 0.15

 -- Dima Kogan <dkogan@debian.org>  Wed, 08 Aug 2018 16:11:27 -0700

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Uploaders: Dima Kogan <dkogan@debian.org>
 Standards-Version: 3.9.6
 Homepage: https://github.com/dkogan/libdogleg
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/libdogleg.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/libdogleg.git
+Vcs-Git: https://salsa.debian.org/science-team/libdogleg.git
+Vcs-Browser: https://salsa.debian.org/science-team/libdogleg
 
 Package: libdogleg2
 Section: libs

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	pod2html --title=libdogleg README.pod > libdogleg.html

override_dh_strip:
	dh_strip --dbgsym-migration='libdogleg2-dbg (<< 0.13-2~)'

override_dh_auto_clean:
	dh_auto_clean
	rm -f libdogleg.html pod2htm*.tmp

## libdogleg 0.16

=== Makefile ===
include choose_mrbuild.mk
include $(MRBUILD_MK)/Makefile.common.header

PROJECT_NAME := dogleg

VERSION      := $(VERSION_FROM_PROJECT)
ABI_VERSION  := 2
TAIL_VERSION := $(VERSION)

LIB_SOURCES += \
  dogleg.c

BIN_SOURCES += \
  sample.c

DIST_INCLUDE += \
  dogleg.h

LDLIBS += -lcholmod -llapack
LDLIBS += -lm

CFLAGS += -Wall -Wextra -I/usr/include/suitesparse

sample.o: CFLAGS += -I.

MAN_SECTION := 3
MAN_TARGET  := libdogleg.$(MAN_SECTION)
DIST_MAN    := $(MAN_TARGET)

$(MAN_TARGET): README.pod
	pod2man --center="libdogleg: Powell's dogleg method" --name=LIBDOGLEG --release="libdogleg $(VERSION)" --section=$(MAN_SECTION) $^ $@

EXTRA_CLEAN += $(MAN_TARGET)

include $(MRBUILD_MK)/Makefile.common.footer

=== debian/changelog ===
libdogleg (0.16-4) unstable; urgency=medium

  * moved dogleg.h to /usr/include to be compatible with the older
    libdogleg-dev packages

 -- Dima Kogan <dkogan@debian.org>  Tue, 18 Jul 2023 22:38:00 -0700

libdogleg (0.16-3) unstable; urgency=medium

  * Added forgotten Breaks, Replaces tags (Closes: #1041410)

 -- Dima Kogan <dkogan@debian.org>  Tue, 18 Jul 2023 21:16:31 -0700

libdogleg (0.16-2) unstable; urgency=medium

  * libdogleg-doc package removed: documentation lives in libdogleg-dev
  * Minor cleanup by the Debian janitor

 -- Dima Kogan <dkogan@debian.org>  Mon, 17 Jul 2023 10:37:41 -0700

libdogleg (0.16-1) unstable; urgency=medium

  * New upstream release
    - Using mrbuild build system
    - I no longer build static libraries
    - Build against suiteparse 7 fixed (Closes: #1041059)

 -- Dima Kogan <dkogan@debian.org>  Mon, 17 Jul 2023 09:51:56 -0700

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: libdogleg
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9.20160114), dh-exec, libsuitesparse-dev | libsuitesparse-metis-dev
+Build-Depends: debhelper-compat (= 13), libsuitesparse-dev | libsuitesparse-metis-dev,
+               mrbuild
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>
 Standards-Version: 3.9.6
@@ -25,32 +26,14 @@
  This library works with sparse matrices, which makes it suitable for
  efficiently solving very large problems.
 
-Package: libdogleg-doc
-Section: doc
-Architecture: all
-Multi-Arch: foreign
-Depends: ${misc:Depends}
-Replaces: libdogleg-dev (<< 0.08-3) 
-Breaks: libdogleg-dev (<< 0.08-3) 
-Description: Powell's dog-leg nonlinear least squares solver for sparse matrices
- Solves unconstrained nonlinear least squares problems using Powell's dog-leg
- method. The user specifies a callback C function that returns the value and
- gradients of the model function at a particular operating point. This library
- takes a series of dog-leg steps to find a local minimum of the residual
- surface.
- .
- This library works with sparse matrices, which makes it suitable for
- efficiently solving very large problems.
- .
- This package contains the documentation
-
 Package: libdogleg-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, libdogleg2 (= ${binary:Version}),
-         libdogleg-doc,
          libsuitesparse-dev | libsuitesparse-metis-dev
+Replaces: libdogleg-doc (<< 0.16-2)
+Breaks:   libdogleg-doc (<< 0.16-2)
 Description: Powell's dog-leg nonlinear least squares solver for sparse matrices
  Solves unconstrained nonlinear least squares problems using Powell's dog-leg
  method. The user specifies a callback C function that returns the value and

=== debian/watch ===
version=4
opts=dversionmangle=s/(?:\+dfsg|\+repack).*$//,\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libdogleg-$1\.tar\.gz/ \
  https://github.com/dkogan/libdogleg/tags .*/v?(\d\S+)\.tar\.gz

## libdogleg 0.17

=== debian/changelog ===
libdogleg (0.17-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Fri, 02 Jan 2026 21:03:47 -0800

## libdogleg 0.18

=== Makefile ===
--- 
+++ 
@@ -11,17 +11,25 @@
   dogleg.c
 
 BIN_SOURCES += \
-  sample.c
+  sample.c \
+  test-misc.c
+
+# I do not distribute ANY binaries
+DIST_BIN_EXCEPT := *
 
 DIST_INCLUDE += \
   dogleg.h
 
-LDLIBS += -lcholmod -llapack
+LDLIBS += -lcholmod -llapack -lsuitesparseconfig
 LDLIBS += -lm
 
-CFLAGS += -Wall -Wextra -I/usr/include/suitesparse
+CFLAGS += -Wall -Wextra
 
 sample.o: CFLAGS += -I.
+
+check: sample test-misc
+	./check.sh
+.PHONY: check
 
 MAN_SECTION := 3
 MAN_TARGET  := libdogleg.$(MAN_SECTION)

=== debian/changelog ===
libdogleg (0.18-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Thu, 08 Jan 2026 14:49:46 -0800

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13), libsuitesparse-dev | libsuitesparse-metis-dev,
+               zsh <!nocheck>,
                mrbuild
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>

=== debian/watch ===
version=4
opts=\
uversionmangle=s/pre/~/ \
https://github.com/dkogan/libdogleg/tags .*/v(\d\S+)\.tar\.gz
